<template>
  <div id="modal" v-if="book">
    <div class="modal-content">
      <div class="header">
        <h2>{{ book.title }}</h2>
      </div>
      <div class="copy">
        <div>
          <img :src="getCoverUrlFor(book, 'L')" />
        </div>
        <p>
          {{ book.title }} was first published in
          {{ book.first_publish_year }} by {{ book.author_name.join(", ") }}. It
          has
          {{
            book.number_of_pages
              ? book.number_of_pages[0]
              : "an unknown number of"
          }}
          pages and it's ISBN is {{ book.isbn ? book.isbn[0] : "unknown" }}.
        </p>
        <p>{{ book.first_sentence ? book.first_sentence[0] : "" }}</p>
        <a @click="clearCurrentBook">Close Link</a>
      </div>
    </div>
    <div class="overlay"></div>
  </div>
</template>

<script>
import { mapActions, mapState } from "vuex";
import OpenLibraryApiService from "../services/OpenLibraryApiService.js";
export default {
  methods: {
    getCoverUrlFor: OpenLibraryApiService.getCoverUrlFor,
    ...mapActions(["clearCurrentBook"]),
  },
  computed: {
    ...mapState({
      book(state) {
        return state.currentBook;
      },
    }),
  },
};
</script>

<style>
p {
  margin-top: 20px;
}
#modal {
  left: 18%;
  position: fixed;
  top: 18%;
  width: 65%;
  box-shadow: 0 3px 7px rgba(0, 0, 0, 0.25);
  box-sizing: border-box;
  transition: all 0.4s ease-in-out;
  -moz-transition: all 0.4s ease-in-out;
  -webkit-transition: all 0.4s ease-in-out;
}

#modal .header,
#modal .footer {
  border-bottom: 1px solid #535353;
  border-radius: 5px 5px 0 0;
}

#modal .footer {
  border: none;
  border-top: 1px solid #e7e7e7;
  border-radius: 0 0 5px 5px;
}

#modal h2 {
  margin: 0;
  color: #fff;
}

#modal .btn {
  float: right;
}

#modal .copy,
#modal .header,
#modal .footer {
  padding: 10px;
  color: #fff;
}

.modal-content {
  background: #ffffff;
  position: relative;
  z-index: 20;
  border-radius: 5px;
  color: #333;
}

#modal .copy {
  background: #cccccc;
}

#modal .overlay {
  background-color: #000;
  background: rgba(0, 0, 0, 0.8);
  height: 100%;
  left: 0;
  position: fixed;
  top: 0;
  width: 100%;
  z-index: 10;
}

.copy a {
  color: #fff;
  border: 1px solid #535353;
  cursor: pointer;
  text-decoration: none;
  display: inline-block;
  padding: 5px 10px;
  border-radius: 5px;
}
</style>
